//{{AFX_INCLUDES()
#include "msflexgrid.h"
//}}AFX_INCLUDES
#if !defined(AFX_EDITDOCTOR_H__B8C7D762_5360_11D8_9309_D4D92BB2724A__INCLUDED_)
#define AFX_EDITDOCTOR_H__B8C7D762_5360_11D8_9309_D4D92BB2724A__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// Editdoctor.h : header file
//

/////////////////////////////////////////////////////////////////////////////
// Editdoctor dialog
#define MaxNumbFieldsInDbPatientRec 100
#define MaxNumbFieldsInDbDoctorRec 40
#define MaxNumbFieldsInDbLensStyleRec 100
class DataBasePage;
#include "YtvButton.h"
#include "YtvEditBox.h"
#include "YtvStatic.h"
#include "YtvRadioBox.h"
#include "YtvComboBox.h"
class Editdoctor : public CDialog
{
// Construction
public:
	Editdoctor(CWnd* pParent = NULL);   // standard constructor
    CString m_strAddionalRegistryOld;
	DataBasePage* m_pdb;
	static	enum entypeRegistryNodes  m_enTypeRegNode;	
	static char* m_pszPatientRecFormat[];
	static char* m_pszDoctorRecFormat[];
	static char* m_pszLensTypeRecFormat[];
	static char* m_pszFullPatientRecFormat[];
	static char* m_pszFullDoctorRecFormat[];
	static char* m_pszFullLensTypeRecFormat[];
	static char* m_pszEditNewLensTypeRecFormat[];
	static struct sttypeRegistryNodes m_arListReg[];
	static char m_szPersSel[];
	static char m_szSel[];
	CString m_pszDbLensStyleRec[MaxNumbFieldsInDbLensStyleRec];
	CString m_pszDbDoctorRec[MaxNumbFieldsInDbDoctorRec];
	CMSFlexGrid* m_pGrid;
	CMSFlexGrid* m_pGridSelected;
	int m_nLastSel;
	int ReadRegistryDB();
	BOOL WriteRegistryDB();
	int RefWriteRegistryDB();
	int RefReadRegistryDB();
	int FindRecord(const char* RecordId, DWORD column=1);
	int FindLastRecord(DWORD column=1);
	HBRUSH   m_hbrDialBrush;
	COLORREF m_clrDialBrush;
	COLORREF m_clrDialBack;
	COLORREF m_clrDialFront;
	HBRUSH   m_hbrButtonsBrush;
    COLORREF m_clrButtonsBrush; 
	COLORREF m_clrButtonsBack;
	COLORREF m_clrButtonsFront;
	HBRUSH   m_hbrStaticBrush;
    COLORREF m_clrStaticBrush; 
	COLORREF m_clrStaticBack;
	COLORREF m_clrStaticFront;
	COLORREF m_clrMsgBoxesBrush; 
	HBRUSH   m_hbrMsgBoxesBrush;
	COLORREF m_clrMsgBoxesBack;
	COLORREF m_clrMsgBoxesFront;
	COLORREF m_clrEditBoxesBrush; 
	HBRUSH   m_hbrEditBoxesBrush;
	COLORREF m_clrEditBoxesBack;
	COLORREF m_clrEditBoxesFront;
	COLORREF m_clrScrollBarsBrush; 
	HBRUSH   m_hbrScrollBarsBrush;
	COLORREF m_clrScrollBarsBack;
	COLORREF m_clrScrollBarsFront;
	COLORREF m_clrListBoxesBrush; 
	HBRUSH   m_hbrListBoxesBrush;
	COLORREF m_clrListBoxesBack;
	COLORREF m_clrListBoxesFront;
// Dialog Data
	//{{AFX_DATA(Editdoctor)
	enum { IDD = IDD_EDITDOCTOR };
	CMSFlexGrid	m_gridLensSelPersonal;
	CMSFlexGrid	m_gridLensTable;
	CEdit	m_edLName;
	CEdit	m_edName;
	CEdit	m_edId;
	CEdit	m_Ad;
	CEdit	m_edNote;
	CEdit	m_OFN;	
	CString	m_szDOfficeName;
	CString	m_szDAddress;
	CString	m_szDoctorId;
	CString	m_szDFirstName;
	CString	m_szDLastName;
	CString	m_szNote;
	//}}AFX_DATA

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(Editdoctor)
	public:
	virtual BOOL Create(CWnd* pParentWnd);
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:

	// Generated message map functions
	//{{AFX_MSG(Editdoctor)
	afx_msg HBRUSH OnCtlColor(CDC* pDC, CWnd* pWnd, UINT nCtlColor);
	virtual BOOL OnInitDialog();
	afx_msg void OnPERSONAl();
	afx_msg void OnSelChangeLensTable();
	afx_msg void OnSelChangeLensSelPersonal();
	afx_msg void OnDeleteSelectedLens();
	afx_msg void OnSave();
	virtual void OnNoChange();
	virtual void OnOK();
	virtual void OnCancel();
	afx_msg int OnCreate(LPCREATESTRUCT lpCreateStruct);
	afx_msg void OnShowWindow(BOOL bShow, UINT nStatus);
	afx_msg void OnMouseMove(UINT nFlags, CPoint point);
	DECLARE_EVENTSINK_MAP()
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_EDITDOCTOR_H__B8C7D762_5360_11D8_9309_D4D92BB2724A__INCLUDED_)
