// PrintPage.cpp : implementation file
//

#include "stdafx.h"
#include "MeasurementPage.h"
#include "CalculatorPage.h"
#include "PrintPage.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// PrintPage property page
extern int g_nHorLineY;
extern int g_nHorMarkLen;
extern int g_nVerMarkLen;
extern BOOL g_bMeasurePageInited;
extern BOOL g_bCalculatePageInited;
extern int g_nHorLineY;
extern BOOL g_bOD;
extern int g_nRow;
extern CString g_szPatientId;
char g_szCompanyName[100]="<Name of Company>";
entypeRegistryNodes PrintPage::m_enTypeRegNode=encFullLensTypeRec;
/*
char* PrintPage::m_pszPatientRecFormat[]={"PatientID","FirstName","LastName","DoctorName", "Nt",NULL};
char* PrintPage::m_pszDoctorRecFormat[]={"OficeName","OficeAddress","DoctorID","FirstName","LastName",NULL};
char* PrintPage::m_pszLensTypeRecFormat[]={"LensMfg","LensName","MfgA_Const","MfgACD","MfgSF",NULL};
char* PrintPage::m_pszFullPatientRecFormat[]={"PatientID","FirstName","LastName","DoctorName", "Nt","DoctorID","DateOfBirth","Sex","Address","City","State","Zip","Phone","RiK1V","RiK2V","RiKV","LeK1V","LeK2V","LeKV",NULL};
char* PrintPage::m_pszFullDoctorRecFormat[]={"DoctorID","FirstName","LastName","Nt","OficeName","OficeAddress",NULL};
char* PrintPage::m_pszFullLensTypeRecFormat[]={"LensMfg","LensName", "MfgA_Const", "pA_Const", "MfgACD", "pACD", "MfgSF", "pSF",NULL};
char* PrintPage::m_pszEditNewLensTypeRecFormat[]={"LensName","LensMfg", "MfgA_Const", "MfgACD","OD1","OD2",
	"OL","LA","PR","OM","LM","PC","Ad","MfgSF","Hd","Hacd","Nt",NULL};
char* PrintPage::m_pszMeasureHistoryTypeRecFormat[]={"SessionDate","InScans","ScanNumber","InScanValues","InOD_OS","InMethod","InMode","OutAL","OutACD","OutLT","OutVIT","AutoManualVCR","ScData","OutDist","SG","Av","Flt"};
char* PrintPage::m_pszCalculatorTypeRecFormat[]={"SessionDate","InScans","ScanNumber","InScanValues","InOD_OS","InMethod","InMode","OutAL","OutACD","OutLT","OutVIT","AutoManualVCR","ScData","OutDist","SG"};
struct sttypeRegistryNodes PrintPage::m_arListReg[]=
{
	{"CommonSettings",NULL,NULL},
	{"Patients",m_pszPatientRecFormat,NULL},
    {"Doctors",m_pszDoctorRecFormat,NULL},
	{"LensesType",m_pszLensTypeRecFormat,NULL},
    {"Patients",m_pszFullPatientRecFormat,NULL},
    {"Doctors",m_pszFullDoctorRecFormat,NULL},
	{"LensesType",m_pszFullLensTypeRecFormat,NULL},
	{"LensesType",m_pszEditNewLensTypeRecFormat,NULL},
	{"Sessions",m_pszMeasureHistoryTypeRecFormat,NULL},
	{"Sessions",m_pszCalculatorTypeRecFormat,NULL}

};*/
char* PrintPage::m_pszPatientRecFormat[]={"PatientID","FirstName","LastName","DoctorName", "Nt",NULL};
char* PrintPage::m_pszDoctorRecFormat[]={"OficeName","OficeAddress","DoctorID","FirstName","LastName",NULL};
char* PrintPage::m_pszLensTypeRecFormat[]={"LensMfg","LensName","MfgA_Const","MfgACD","MfgSF",NULL};
char* PrintPage::m_pszFullPatientRecFormat[]={"PatientID","FirstName","LastName","DoctorName", "Nt","DoctorID","DateOfBirth","Sex","Address","City","State","Zip","Phone","RiK1V","RiK2V","RiKV","LeK1V","LeK2V","LeKV",NULL};
char* PrintPage::m_pszFullDoctorRecFormat[]={"DoctorID","FirstName","LastName","Nt","OficeName","OficeAddress",NULL};
char* PrintPage::m_pszFullLensTypeRecFormat[]={"LensMfg","LensName", "MfgA_Const", "pA_Const", "MfgACD", "pACD", "MfgSF", "pSF",NULL};
char* PrintPage::m_pszEditNewLensTypeRecFormat[]={"LensName","LensMfg", "MfgA_Const", "MfgACD","OD1","OD2",
	"OL","LA","PR","OM","LM","PC","Ad","MfgSF","Hd","Hacd","Nt",NULL};
char* PrintPage::m_pszMeasureHistoryTypeRecFormat[]={"SessionDate","InScans","ScanNumber","InScanValues","InOD_OS","InMethod","InMode","OutAL","OutACD","OutLT","OutVIT","AutoManualVCR","ScData","OutDist","SG","Av","Flt","CTh","LTh1","LTh2","RTh","AvAl","SD",NULL};
char* PrintPage::m_pszCalculatorTypeRecFormat[]={"SessionDate","InScans","ScanNumber","InScanValues","InOD_OS","InMethod","InMode","OutAL","OutACD","OutLT","OutVIT","AutoManualVCR","ScData","OutDist","SG","Av","Flt","CTh","LTh1","LTh2","RTh","AvAl","SD",NULL};
struct sttypeRegistryNodes PrintPage::m_arListReg[]=
{
	{"CommonSettings",NULL,NULL},
	{"Patients",m_pszPatientRecFormat,NULL},
    {"Doctors",m_pszDoctorRecFormat,NULL},
	{"LensesType",m_pszLensTypeRecFormat,NULL},
    {"Patients",m_pszFullPatientRecFormat,NULL},
    {"Doctors",m_pszFullDoctorRecFormat,NULL},
	{"LensesType",m_pszFullLensTypeRecFormat,NULL},
	{"LensesType",m_pszEditNewLensTypeRecFormat,NULL},
	{"Sessions",m_pszMeasureHistoryTypeRecFormat,NULL},
	{"Sessions",m_pszCalculatorTypeRecFormat,NULL},
//	{"Sessions",m_pszPrintTypeRecFormat,NULL},
//	{"Scans",m_pszScansTypeRecFormat,NULL}
};
IMPLEMENT_DYNCREATE(PrintPage, CPropertyPage)

PrintPage::PrintPage() : CPropertyPage(PrintPage::IDD)
{
	//{{AFX_DATA_INIT(PrintPage)
	m_nFormula = 0;
	m_bPrintCalculation = TRUE;
	m_bPrintScan = TRUE;
	m_bSetupPrinter = FALSE;
	m_bPreview = FALSE;
	m_bStartPrint = FALSE;
	//}}AFX_DATA_INIT
	m_hbm=NULL;
	m_clrDialBack=RGB(0,0,0);
	m_clrDialFront=RGB(0,0,0);
	m_clrDialBrush=RGB(0,255,0);    
   	m_hbrDialBrush=CreateSolidBrush(m_clrDialBrush);
	m_clrButtonsBrush=RGB(255,0,0); 
	m_hbrButtonsBrush=CreateSolidBrush(m_clrButtonsBrush);
	m_clrButtonsBack=RGB(255,0,0);
	m_clrButtonsFront=RGB(0,255,0);
	m_clrStaticBrush=RGB(0,255,0); 
	m_clrStaticBack=RGB(0,255,0);
	m_clrStaticFront=RGB(0,0,0);
	m_hbrStaticBrush=CreateSolidBrush(m_clrStaticBrush);
	m_clrMsgBoxesBrush=RGB(255,0,0); 
	m_hbrMsgBoxesBrush=CreateSolidBrush(m_clrButtonsBrush);
	m_clrMsgBoxesBack=RGB(255,0,0);
	m_clrMsgBoxesFront=RGB(255,255,255);
	m_clrEditBoxesBrush=RGB(255,255,255); 
	m_hbrEditBoxesBrush=CreateSolidBrush(m_clrButtonsBrush);
	m_clrEditBoxesBack=RGB(255,255,255);
	m_clrEditBoxesFront=RGB(0,0,0);
	m_clrScrollBarsBrush=RGB(255,0,0); 
	m_hbrScrollBarsBrush=CreateSolidBrush(m_clrButtonsBrush);
	m_clrScrollBarsBack=RGB(255,0,0);
	m_clrScrollBarsFront=RGB(255,255,255);
	m_clrListBoxesBrush=RGB(255,0,0); 
	m_hbrListBoxesBrush=CreateSolidBrush(m_clrButtonsBrush);
	m_clrListBoxesBack=RGB(255,0,0);
	m_clrListBoxesFront=RGB(255,255,255);
	m_nStartPrint=0;
	m_nMemorySize=1024;
	m_npDataBuf=new int[m_nMemorySize];	 
	for(int i=0; i<m_nMemorySize;i++)
       m_npDataBuf[i]=0;
	m_strScanNumber.Empty();
}

PrintPage::~PrintPage()
{
	if(m_npDataBuf)
		delete []m_npDataBuf;
}

void PrintPage::DoDataExchange(CDataExchange* pDX)
{
	CPropertyPage::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(PrintPage)
	DDX_Radio(pDX, IDC_METHOD1, m_nFormula);
	DDX_Control(pDX, IDC_PATIENTIDPRINT, m_gridPatientPrint);
	DDX_Check(pDX, IDC_PRINTCALCULATION, m_bPrintCalculation);
	DDX_Check(pDX, IDC_PRINTSCAN, m_bPrintScan);
	DDX_Check(pDX, IDC_PRINTERSETUP, m_bSetupPrinter);
	DDX_Check(pDX, IDC_PREVIEW, m_bPreview);
	DDX_Check(pDX, IDC_START_PRINT, m_bStartPrint);
	DDX_Control(pDX, IDC_YTVGRAPHPRINT, m_imGraph);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(PrintPage, CPropertyPage)
	//{{AFX_MSG_MAP(PrintPage)
	ON_WM_CTLCOLOR()
	ON_BN_CLICKED(IDC_PREVIEW, OnPreview)
	ON_BN_CLICKED(IDC_PRINTERSETUP, OnPrintersetup)
	ON_WM_PAINT()
	ON_BN_CLICKED(IDC_START_PRINT, OnStartPrint)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// PrintPage message handlers

HBRUSH PrintPage::OnCtlColor(CDC* pDC, CWnd* pWnd, UINT nCtlColor) 
{
  switch(nCtlColor)
	{
		default:

			return CPropertyPage::OnCtlColor(pDC, pWnd, nCtlColor);
			
		case CTLCOLOR_BTN: //  Button control
            SetTextColor(pDC->m_hDC,m_clrButtonsFront);
			SetBkColor(pDC->m_hDC,m_clrButtonsBack); 
            return m_hbrButtonsBrush;
						            
        case CTLCOLOR_DLG://   Dialog box
            SetTextColor(pDC->m_hDC,m_clrDialFront);
			SetBkColor(pDC->m_hDC,m_clrDialBack); 
            return m_hbrDialBrush;               
case CTLCOLOR_EDIT://   Edit control
            SetTextColor(pDC->m_hDC,m_clrEditBoxesFront);
			SetBkColor(pDC->m_hDC,m_clrEditBoxesBack);  
            return m_hbrEditBoxesBrush;
case CTLCOLOR_LISTBOX://   List-box control
            SetTextColor(pDC->m_hDC,m_clrListBoxesFront);
			SetBkColor(pDC->m_hDC,m_clrListBoxesBack);  
            return m_hbrListBoxesBrush;
case CTLCOLOR_MSGBOX://   Message box
            SetTextColor(pDC->m_hDC,m_clrMsgBoxesFront);
			SetBkColor(pDC->m_hDC,m_clrMsgBoxesBack); 
			return m_hbrMsgBoxesBrush;
case CTLCOLOR_SCROLLBAR://   Scroll-bar control
            SetTextColor(pDC->m_hDC,m_clrScrollBarsFront);
			SetBkColor(pDC->m_hDC,m_clrScrollBarsBack);  
            return m_hbrScrollBarsBrush;
case CTLCOLOR_STATIC://   Static control 
            SetTextColor(pDC->m_hDC,m_clrStaticFront); 
            SetBkColor(pDC->m_hDC,m_clrStaticBack); 
            return m_hbrStaticBrush;
	}
	
	// TODO: Return a different brush if the default is not desired
	return CPropertyPage::OnCtlColor(pDC, pWnd, nCtlColor);
}

BOOL PrintPage::OnInitDialog() 
{
	CPropertyPage::OnInitDialog();	
	// TODO: Add extra initialization here
	m_imGraph.SetGraphType(2); 
	RECT rt;
	m_imGraph.GetWindowRect(&rt);
	rt.bottom-=rt.top;
	rt.right-=rt.left-1;	
	m_imGraph.SetCleanByBrush(TRUE);
	short BegY=(short)rt.bottom;
	short LenX=(short)rt.right;
	short LenY=(short)rt.bottom;
	short HSmall=10;
	short HMedium=18;
	short HLong=24;	
    short StepSmall=(short)(((double)rt.right)/39.5+0.5);
	short StepLong=StepSmall*10;
	short StepMedium=StepSmall*5;
	short DirectionUpDownCenter=-1;
	short AxisLineType=1;
	short nNewValue=0;
	short BegX=0;
	long TextStepSmall=0;
	long TextStepMedium=5;
	long TextStepLong=10;
	long TextBeginCount=0;
    m_imGraph.SetDividingLineColor(RGB(0,0,0));
	m_imGraph.SetScalePlankColor(RGB(0,0,0));
	m_imGraph.SetBackTextColor(RGB(255,255,255));
	m_imGraph.SetChartLineSecondColor(RGB(0,0,0));
	m_imGraph.SetChartLineColor(RGB(0,0,0));
	m_imGraph.SetChartBrushColor(RGB(255,255,255));
	m_imGraph.SetScalePlank(&BegX, &BegY, &LenX, &LenY, &HSmall, &HMedium, &HLong, &StepSmall, &StepMedium, &StepLong, &DirectionUpDownCenter, &AxisLineType, nNewValue);
   	m_imGraph.SetScalePlankTextHoriz(&TextStepSmall, &TextStepMedium, &TextStepLong, TextBeginCount); 
	m_imGraph.SetDrawScalePlank(TRUE);
	m_imGraph.SetBottomVerticalPosition(HLong+1);
	g_nHorLineY+=HLong+1;
	m_imGraph.SetTopVerticalPosition(5);
	//m_imGraph.SetHMultiFactor(m_dHMultifactor);
    m_imGraph.SetIPoints((long*)m_npDataBuf,m_nMemorySize);
	m_gridPatientPrint.SetCols(2);
	m_gridPatientPrint.SetRows(2);
	m_gridPatientPrint.SetFixedRows(0);
    m_gridPatientPrint.SetColWidth(0,1050);
    m_gridPatientPrint.SetColWidth(1,3800); 
	m_gridPatientPrint.SetTextMatrix(0, 0, "Patient ID");
    m_gridPatientPrint.SetTextMatrix(1, 0, "Patient Name");
	m_strMfg.Empty();
	m_dAconst=0.0;
    m_dAcd=0.0;
    m_dSF=0.0;
	m_dRx=0.0;
	m_nFontHeight=10;
   
    //ReadRegDB();
    //m_struPrintInfo.
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}


BOOL PrintPage::OnSetActive() 
{
	// TODO: Add your specialized code here and/or call the base class
	UpdateData();
	ReadRegDB();
	DoctorRefReadRegistryDB();  
	UpdateData(FALSE);
	m_font.CreateFont(m_nFontHeight, 0, 0, 0, FW_BOLD, FALSE, FALSE,
               0, ANSI_CHARSET, OUT_DEFAULT_PRECIS,
               CLIP_DEFAULT_PRECIS, DEFAULT_QUALITY,
               FF_DONTCARE, NULL);  
	return CPropertyPage::OnSetActive();
}

void PrintPage::OnPrintersetup() 
{
	// TODO: Add your control notification handler code here
	UpdateData();
	m_bPreview=FALSE;
	m_bStartPrint=FALSE;
	UpdateData(FALSE);
	//AfxGetApp()->OnFilePrintSetup();
	AfxGetMainWnd()->PostMessage(WM_COMMAND,ID_FILE_PRINT_SETUP,0);
    m_bSetupPrinter=FALSE;
	UpdateData(FALSE);
}

int PrintPage::ReadRegDB()
{
	m_szPatient_Id=g_szPatientId; 
    if(m_szPatient_Id.IsEmpty())
	   return 0;
    m_enTypeRegNode=encFullPatientTypeRec;
	YtvSetAdditionalRegNode(m_arListReg[m_enTypeRegNode].Node);
   	m_gridPatientPrint.SetTextMatrix(0, 1, g_szPatientId);//id 
	int j;
	CString Temp0,Temp1;
	char *pf;
    if(m_arListReg[m_enTypeRegNode].Format==NULL)
		return 0;  
    pf=m_arListReg[m_enTypeRegNode].Format[2];
	if(pf==NULL)
		return 0;
	UpdateData();
	m_arListReg[encFullPatientTypeRec].Data=new CString[19];
	for(j=0;;j++)
    {
           pf=m_arListReg[m_enTypeRegNode].Format[j];
		   if(pf==NULL)
			   break;
		   m_arListReg[m_enTypeRegNode].Data[j]=YtvGetProfileString(m_szPatient_Id,pf,"",1); 		 
    }   
	m_szFirstname=m_arListReg[encFullPatientTypeRec].Data[1];
	m_szLastname=m_arListReg[encFullPatientTypeRec].Data[2];
	Temp0=m_szFirstname+' '+m_szLastname;
	Temp0.TrimLeft();
    m_gridPatientPrint.SetTextMatrix(1, 1, Temp0); 
    m_szDoctorName=m_arListReg[encFullPatientTypeRec].Data[3];
	//m_gridAPATID.SetTextMatrix(2, 1,m_szDoctorName);
    m_szNote=m_arListReg[encFullPatientTypeRec].Data[4];
	m_szDoctorId=m_arListReg[encFullPatientTypeRec].Data[5];
	Temp0=m_arListReg[encFullPatientTypeRec].Data[6];
	j=Temp0.Find('/');
	if(j>0)
	{
		m_szDob_mm=Temp0.Left(j);
		Temp0=Temp0.Mid(j+1);
        j=Temp0.Find('/');
	    if(j>0)
		{
           m_szDob_dd=Temp0.Left(j);
		   m_szDob_yy=Temp0.Mid(j+1);
        }
    }	
	if(m_arListReg[encFullPatientTypeRec].Data[7]=="M")
	      m_nGender=0;
    else
          m_nGender=1;
	m_szP_Address=m_arListReg[encFullPatientTypeRec].Data[8];
	m_szP_city=m_arListReg[encFullPatientTypeRec].Data[9];
    m_szP_state=m_arListReg[encFullPatientTypeRec].Data[10];
    m_szP_zip=m_arListReg[encFullPatientTypeRec].Data[11];
	m_szP_phone=m_arListReg[encFullPatientTypeRec].Data[12];
    m_szK1_value_r=m_arListReg[encFullPatientTypeRec].Data[13];
    m_szK2_value_r=m_arListReg[encFullPatientTypeRec].Data[14];
	m_szK_value_r=m_arListReg[encFullPatientTypeRec].Data[15];
	m_szK1_value_l=m_arListReg[encFullPatientTypeRec].Data[16];
    m_szK2_value_l=m_arListReg[encFullPatientTypeRec].Data[17];
	m_szK_value_l=m_arListReg[encFullPatientTypeRec].Data[18];	
	delete []m_arListReg[encFullPatientTypeRec].Data;
    m_arListReg[encFullPatientTypeRec].Data=NULL;	
//	SetEyePar();    
	UpdateData(FALSE);
	return 19;
}

int PrintPage::DoctorRefReadRegistryDB()
{
  int numbselected=0,numbchar,nr,i,s;
  char* pch,*pchtemp;
  m_nLastSel=0;
//  if(m_pGrid==NULL)
//	  return numbselected;
  	m_enTypeRegNode=encFullDoctorTypeRec;
	YtvSetAdditionalRegNode(m_arListReg[m_enTypeRegNode].Node);
    m_arListReg[m_enTypeRegNode].Data=m_pszDbDoctorRec; 
    m_arListReg[m_enTypeRegNode].Data[0]=m_szDoctorId;
	m_szNoteD=YtvGetProfileString(m_arListReg[m_enTypeRegNode].Data[0],m_arListReg[m_enTypeRegNode].Format[3],"",1);
	m_szDOfficeName=YtvGetProfileString(m_arListReg[m_enTypeRegNode].Data[0],m_arListReg[m_enTypeRegNode].Format[4],"",1);
	m_szDAddress=YtvGetProfileString(m_arListReg[m_enTypeRegNode].Data[0],m_arListReg[m_enTypeRegNode].Format[5],"",1);
	UpdateData(FALSE);
  if(m_arListReg[encFullDoctorTypeRec].Data==NULL)
	  return 0;
  m_enTypeRegNode=encFullDoctorTypeRec;
  YtvSetAdditionalRegNode(m_arListReg[m_enTypeRegNode].Node);  
  CString  Subsection,Section=m_arListReg[encFullDoctorTypeRec].Data[0],Temp,TempS;
  Section+='\\';
  Section+=m_arListReg[encLensTypeRec].Node; //lenses  
  Section+='\\';
  numbchar=YtvGetProfileSection(Section,NULL,0,1);
  if(numbchar==0)
  {
	  return numbselected;

  }
  pch=new char[numbchar+1];
  numbchar=YtvGetProfileSection(Section,pch,numbchar+1,1);
  if(numbchar==0)
  {
	  delete []pch;
	  return numbselected;
  }
  pchtemp=pch;
  //nr=m_pGrid->GetRows();
  //nc=m_pGrid->GetCols();
  Section+='\\';
  int nsel=0;
  nr=m_NumbRecords+1;
  for(i=1;pchtemp[0];pchtemp+=strlen(pchtemp)+1)
  {
	   Temp=pchtemp;
	   s=Temp.Find('=');
	   if(s>=0)
	      Temp=Temp.Left(s);
	   if(Temp.IsEmpty())
		   continue;
	    // m_pGrid->SetTextMatrix(i,0,Editdoctor::m_szSel);
        // m_pGrid->SetTextMatrix(i,2,Temp);		
		 m_nLastSel++;
		 nsel++;
       	 Subsection=Section+Temp;			
         TempS=YtvGetProfileString(Subsection,m_arListReg[encFullLensTypeRec].Format[0],"",1); 
         if(TempS==Temp)
         {
			//m_pGrid->SetTextMatrix(i,0,Editdoctor::m_szPersSel); 
            Temp=YtvGetProfileString(Subsection,m_arListReg[encFullLensTypeRec].Format[1],"",1); 
			//m_pGrid->SetTextMatrix(i,1,Temp);	
			m_strMfg=Temp;
		    Temp=YtvGetProfileString(Subsection,m_arListReg[encFullLensTypeRec].Format[3],"",1); 
			if(atof(Temp)==0.0)
                Temp=YtvGetProfileString(Subsection,m_arListReg[encFullLensTypeRec].Format[2],"",1); 
			//m_gridDACONST.SetTextMatrix(0,1,Temp);
			m_dAconst=atof(Temp);
            Temp=YtvGetProfileString(Subsection,m_arListReg[encFullLensTypeRec].Format[5],"",1); 
			if(atof(Temp)==0.0)
                Temp=YtvGetProfileString(Subsection,m_arListReg[encFullLensTypeRec].Format[4],"",1); 
            m_dAcd=atof(Temp);
			Temp=YtvGetProfileString(Subsection,m_arListReg[encFullLensTypeRec].Format[7],"",1); 
			if(atof(Temp)==0.0)
                Temp=YtvGetProfileString(Subsection,m_arListReg[encFullLensTypeRec].Format[6],"",1); 
			m_dSF=atof(Temp);
         }
		 else
			  i++;
		 if(i>4)
			 break;
          
  }
  delete []pch;  
  UpdateData(FALSE);
  return numbselected;
}


void PrintPage::Serialize(CArchive& ar) 
{
	if (ar.IsStoring())
	{	// storing code
	}
	else
	{	// loading code
	}
}

void PrintPage::OnPaint() 
{
	CPaintDC dc(this); // device context for painting
	
	// TODO: Add your message handler code here
	
	// Do not call CPropertyPage::OnPaint() for painting messages
}
void PrintPage::OnStartPrint() 
{
	// TODO: Add your control notification handler code here
	//get from view which inserts read from doc
	//m_hbm
	//CalculateMFG();
	UpdateData();
	m_bSetupPrinter=FALSE;
	m_bPreview=FALSE;
	m_nStartPrint=2;	
	//AfxGetApp()->OnFilePrint();
    AfxGetMainWnd()->PostMessage(WM_COMMAND,ID_FILE_PRINT,0);
	m_bStartPrint=FALSE;
	UpdateData(FALSE);
	Invalidate();
	m_imGraph.Invalidate();
}

void PrintPage::OnPreview() 
{
	// TODO: Add your control notification handler code here
	//m_hbm
	UpdateData();
	//CalculateMFG();
	m_bSetupPrinter=FALSE;	
	m_bStartPrint=FALSE;
   	m_nStartPrint=1;	
	//AfxGetApp()->OnFilePrintPreview();
	AfxGetMainWnd()->PostMessage(WM_COMMAND,ID_FILE_PRINT_PREVIEW,0);
	m_bPreview=FALSE;
	UpdateData(FALSE);
}

void PrintPage::DisplayGraph()
{
//m_imGraph.CleanReDraw(0);
m_imGraph.SetIPoints((long *)m_npDataBuf,m_nMemorySize);
DrawMarks(0);
}
BOOL PrintPage::PlayScan(const char* SesDate,const char* ScanNum)
{
	UpdateData();
   // m_strSlideCount.Format("%d",m_nNextScan);
    //m_edSlideCount.SetWindowText(m_strSlideCount);
CString Temp0,Temp1;
	char *pf;
	const unsigned char *pd;
	int NumbRecords=0;
	m_enTypeRegNode=encMeasureHistorySessionScansTypeRec;   
	CString Section=m_szPatient_Id;
	Section+="\\";
	Section+=m_arListReg[m_enTypeRegNode].Node;
    Section+="\\";
	Temp0=SesDate;
	Temp0.Replace('/','_');
	Section+=Temp0;
    if(m_arListReg[m_enTypeRegNode].Format==NULL)
		return FALSE;
    Section+="\\";
	CString Subsection;
    Section+=m_arListReg[m_enTypeRegNode].Format[1];//scans directory
   	Section+="\\";
	CString Temp;
	int Group;
		Temp=ScanNum;
       	Subsection=Section+Temp;//scan number directory
		/////////////////////////////////////////////////
        pf=m_arListReg[m_enTypeRegNode].Format[14];
		if(pf==NULL)
			  return FALSE;
		Group=YtvGetProfileInt(Subsection,pf,-1,1); 
		m_nCurrentScanGroup=atoi(m_strGroupScan);
		////////////////////////////////////////////
       	///////////////////////////????????????
	  	/////////////////////////////////////////////////////
	    pf=m_arListReg[m_enTypeRegNode].Format[12];
		if(pf==NULL)
			  return FALSE;
		m_nMemorySize=m_nMemorySize*4;
		pd=YtvGetProfileBinary(Subsection,pf,NULL,&m_nMemorySize,1);
	    if(!pd)
		{
			m_nMemorySize=1024;
			return  FALSE;
        }
		memcpy((void *)m_npDataBuf,(void *)pd,m_nMemorySize);
        m_nMemorySize=1024;
		//	{"SessionDate","InScans","ScanNumber","InScanValues","InOD_OS","InMethod","InMode","OutAL","OutACD","OutLT","OutVIT","ScData"};
	   	//////////////////////////////////////
        pf=m_arListReg[m_enTypeRegNode].Format[17];
		if(pf==NULL)
			  return  FALSE;
		m_curThr.Pics[encCorniaThreshHold]=YtvGetProfileInt(Subsection,pf,-5,1);
	    pf=m_arListReg[m_enTypeRegNode].Format[20];
		if(pf==NULL)
			  return  FALSE;
		m_curThr.Pics[encRetinaThreshHold]=YtvGetProfileInt(Subsection,pf,-5,1);
		pf=m_arListReg[m_enTypeRegNode].Format[18];
		if(pf==NULL)
			  return  FALSE;
		m_curThr.Pics[encLensThreshHoldBegin]=YtvGetProfileInt(Subsection,pf,-5,1);
		pf=m_arListReg[m_enTypeRegNode].Format[19];
		if(pf==NULL)
			  return  FALSE;
		m_curThr.Pics[encLensThreshHoldEnd]=YtvGetProfileInt(Subsection,pf,-5,1);
		memcpy(m_NumbPics,m_curThr.Pics,sizeof(m_NumbPics));

    	
 
 UpdateData(FALSE);
 DisplayGraph();
  return TRUE;
}
void PrintPage::DrawMarks(unsigned int MakeSound)
{
RECT rt;
int i,j;
short pX[17], pY[17], pType[17];
m_imGraph.GetClientRect(&rt);
i=0;
for(j=0;j<4;j++)
{
  if(m_NumbPics[j]>=0)
  {
    ++i;
	pX[i]=m_imGraph.PixelFromDataXCoor(m_NumbPics[j])-g_nHorMarkLen;
	if(pX[i]<0)
		pX[i]=0;
	if(pX[i]>rt.right)
		pX[i]=(short)rt.right;
    pY[i]=g_nHorLineY;
	pType[i]=0;
	///////////////////////////////////
	++i;
	pX[i]=m_imGraph.PixelFromDataXCoor(m_NumbPics[j])+g_nHorMarkLen;
    if(pX[i]>rt.right)
		pX[i]=(short)rt.right;
	if(pX[i]<0)
		pX[i]=0;
    pY[i]=g_nHorLineY;
	pType[i]=1;
	////////////////////////////////
	++i;
    pX[i]=(short)m_imGraph.PixelFromDataXCoor(m_NumbPics[j]);
	if(pX[i]>rt.right)
		pX[i]=(short)rt.right;
	if(pX[i]<0)
		pX[i]=0;
    pY[i]=g_nHorLineY+g_nVerMarkLen;
	pType[i]=0;
	/////////////////////////////////
	++i;
	pX[i]=(short)m_imGraph.PixelFromDataXCoor(m_NumbPics[j]);
	if(pX[i]>rt.right)
		pX[i]=(short)rt.right;
	if(pX[i]<0)
		pX[i]=0;
    pY[i]=g_nHorLineY-g_nVerMarkLen;
	pType[i]=1;
  }
  //m_NumbPics[j]=-1;

}
  if(i>0)
  {
	  m_imGraph.SetDrawLines(pX, pY, pType, i+1);
	  if(MakeSound)
	         MessageBeep(MB_ICONEXCLAMATION);
  }
  else
	m_imGraph.SetDrawLines(NULL, NULL, NULL, 0);
  m_imGraph.Invalidate(FALSE);
}
void PrintPage::OnDraw(CDC* pDC,CCalculatorPage* pcp,MeasurementPage* pmp,CPrintInfo* pInfo) 
{
	RECT rt;
	HWND hw;
	int rr;
	CFont cfont;
	BOOL bManualMeasure;
    POINT ptLeftTop,ptRightTop,ptRightBottom,ptLeftBottom,
		ptVerticalTop,ptHorizontalLeft,ptVerticalBottom,ptHorizontalRight;    
	CSize sz;
	BOOL bIUD;
	short xb,yb=20,c,r,rows,cols,count,xl=20,width,height,lensrows;
	int yr=10,xr=10,k;
	CString ALDist,NameAL_DIST,Shift="            ",Temp,Temp0,Temp1,Header;
	//if(m_nStartPrint==0)
	//	return;
	if(!pDC)
		return;
	if(!pcp)
		return;
	if(!pmp)
		return;
	if(pDC->GetWindow())
	   hw=pDC->GetWindow()->m_hWnd;
	else
		hw=0;
	if(IsWindow(hw))
    {
	  hw=::GetParent(hw);
	  //GetWindowRect(&rt);
	  //ScreenToClient(&rt);
	  rt.right=GetSystemMetrics(SM_CXFULLSCREEN);
	  rt.bottom=GetSystemMetrics(SM_CYFULLSCREEN)+2*GetSystemMetrics(SM_CYCAPTION)+GetSystemMetrics(SM_CYEDGE)+GetSystemMetrics(SM_CYEDGE);
	  rt.left=0;
	  rt.top=-GetSystemMetrics(SM_CYCAPTION)-GetSystemMetrics(SM_CYEDGE);
	  ::MoveWindow(hw,rt.left,rt.top,rt.right,rt.bottom,TRUE);
    }
	if(!g_bMeasurePageInited)
		return;
	if(pmp->m_gridPatient.GetTextMatrix(0,1)!=this->m_gridPatientPrint.GetTextMatrix(0,1))
		return;
	ReadRegDB();
	xb=xl;
	if(pInfo)
    {
		rt=pInfo->m_rectDraw;
	    pDC->Rectangle(xr,yr,rt.right-xr,rt.bottom-yr);	
		ptRightTop.x=rt.right-xr,rt;
	    ptRightTop.y=rt.bottom-yr;	
		ptHorizontalRight.x=ptRightBottom.x=ptRightTop.x;
    }
    pDC->GetTextMetrics(&m_tme);
	m_pfont=(CFont*)pDC->SelectObject(&m_font);
	m_pfont->GetLogFont(&m_logfont);
	m_logfont.lfWeight=FW_BOLD;
    m_logfont.lfHeight=m_tme.tmHeight;
    m_logfont.lfWidth=m_tme.tmAveCharWidth;
	pDC->SelectObject(m_pfont);
	cfont.CreateFontIndirect(&m_logfont);
    pDC->TextOut(xb,yb,g_szCompanyName);
	m_strDate=pmp->m_gridPatient.GetTextMatrix(2,1);
	Temp.Format("%s    %s",m_strDate,pmp->m_szTodayTime);
	//Temp=pmp->m_gridPatient.GetTextMatrix(2,0)+" "+pmp->m_gridPatient.GetTextMatrix(2,1);
	pDC->TextOut(xb+rt.right/2,yb,Temp);//time
	sz=pDC->GetTextExtent(Temp);
    yb+=sz.cy+2;
    Temp="Patient Name: "+m_gridPatientPrint.GetTextMatrix(1,1);//patient name
	pDC->TextOut(xb,yb,Temp);
    Temp="Doctor Name: "+m_szDoctorName;
	pDC->TextOut(xb+rt.right/2,yb,Temp);
	sz=pDC->GetTextExtent(Temp);
    yb+=sz.cy+2;
   	Temp="Patient ID: "+m_gridPatientPrint.GetTextMatrix(0,1);
	pDC->TextOut(xb,yb,Temp);
	Temp="Eye Examined: ";
	if(pmp->m_bOD)
    {
      Temp+="Right";
     //Temp.Format("Right eye: K1=%s;K2=%s;K=%s",m_szK1_value_r,m_szK2_value_r,m_szK_value_r);
	}
	else
    {
	  Temp+="Left";
      //Temp.Format("Left eye: K1=%s;K2=%s;K=%s",m_szK1_value_l,m_szK2_value_l,m_szK_value_l);
    }
	pDC->TextOut(xb+rt.right/2,yb,Temp);
	sz=pDC->GetTextExtent(Temp);
    yb+=sz.cy+2;
 if(m_bPrintScan)
 {
	if(pmp->m_nAuto==0 || (pmp->m_nAuto==1 && pmp->m_bFilterNotInManualMode))
    {
	  Temp="Mode: ";
	  if(pmp->m_nCataract==0)
	  {
		  Temp+="Cataract";
      }
	  else
		Temp+="Aphacic";
	  Temp+="; Method: ";
	  if(pmp->m_nContact==0)
        Temp+="Contact";
	  else
        Temp+="Immersion";	 
	  bManualMeasure=FALSE;
	  Header.Format("AVG AL = %5s mm",pmp->m_gridMaAvSd.GetTextMatrix(0,1));
    }
	else
	{
		Temp="Manual Measure"; 
		Header.Format("Used Dist = %5s mm",pcp->m_gridAL.GetTextMatrix(0,1));
		bManualMeasure=TRUE;
    }	
    pDC->TextOut(xb,yb,Temp);
	sz=pDC->GetTextExtent(Temp);
	yb+=sz.cy+sz.cy+sz.cy+2;
      m_imGraph.SetExternalDeviceContext((long)pDC->m_hDC);
	  if(pInfo)
          rt=pInfo->m_rectDraw;
	  if(!bManualMeasure)
	      Temp.Format("Scans Averaged = %d",pmp->m_nLastSelectedScanNumber);
	  else
          Temp.Format("Manually Scaned = %d",pmp->m_nLastSelectedScanNumber);
	  sz=pDC->GetTextExtent(Temp);
	  pDC->TextOut(xb+(rt.right-sz.cx)/2,yb,Temp);
	  sz=pDC->GetTextExtent(Header);
      pDC->TextOut(xb+((rt.right-sz.cx)/5)*4,yb,Header);
	  if(!bManualMeasure)
      {        
        Temp.Format("SD = %4s",pmp->m_gridMaAvSd.GetTextMatrix(1,1)); 
       	yb+=sz.cy+2;
		pDC->TextOut(xb+((rt.right-sz.cx)/5)*4,yb,Temp);
		yb+=sz.cy+2;
	  }
	  yb+=sz.cy+2;
	  yb+=sz.cy+2;
	  rt.bottom/=4;
	  rt.right/=2;
	  rt.bottom-=30;
	  rt.right-=30;
	  rows=(short)pmp->m_gridSquares.GetRows();
	  count=0;
	  xb=xl;
	  cols=(short)pmp->m_gridSquares.GetCols();
      for(r=1;r<rows;r++)
      {
        Temp=pmp->m_gridSquares.GetTextMatrix(r,0); 
        if(Temp.IsEmpty())
			break;
        pmp->m_gridSquares.SetCol(0);
		pmp->m_gridSquares.SetRow(r);
        if(pmp->m_gridSquares.GetCellBackColor()!=RGB(0,255,0))
			continue;
		m_strScanNumber=Temp;
		pmp->m_delThr=pmp->m_arThreshHolds.GetAt(r);
	    Temp.Format("%06u",pmp->m_delThr.Pics[encDbScanId]);		
		width=(short)rt.right;
		height=(short)(((double)rt.bottom)*0.8);
		if(!PlayScan(m_strDate,Temp))
			continue;
        m_imGraph.SetExternalDeviceContextRectangle(&xb,&yb,&width,&height,TRUE);
	    m_imGraph.Invalidate(FALSE);
        m_imGraph.UpdateWindow();
        if(cols==2)
		{
			if(pmp->m_nAuto==1 && pmp->m_bFilterNotInManualMode==FALSE)
                 Temp.Format("Scan #%d    Dist = %6s mm",atoi(m_strScanNumber),pmp->m_gridSquares.GetTextMatrix(r,1));
			else
			     Temp.Format("Scan #%d      AL = %6s mm",atoi(m_strScanNumber),pmp->m_gridSquares.GetTextMatrix(r,1));
		}
		else
                 Temp.Format("Scan #%d      AL = %6s mm  ACD = %4s mm",atoi(m_strScanNumber),pmp->m_gridSquares.GetTextMatrix(r,1)
		                  ,pmp->m_gridSquares.GetTextMatrix(r,3));
		pDC->TextOut(xb,yb-sz.cy+14,Temp);
		if(count%2==0)
        {			
            xb+=width+20;
        }
		else
        {
           xb=xl;
		   yb+=height+20;
        }
		count++;		
	  }

 }
 /////////////////////////////////////////////////////////////////////
	if(m_bPrintCalculation && g_bCalculatePageInited && pcp->m_gridAPATID.GetTextMatrix(0,1)==this->m_gridPatientPrint.GetTextMatrix(0,1))
    {
      xb=xl;
	  if(count==1 || count==3)
		  yb+=height+20;
      Temp="IOL Calculation";
      pDC->TextOut(xb,yb,Temp);
	  sz=pDC->GetTextExtent(Temp);	
	  Temp="Formula: ";
	  switch(m_nFormula)
      {
	  default:
	  case 0:
          Temp+="METHOD1";
		  break;
	  case 1:
          Temp+="METHOD0";
		  break;
	  case 2:
          Temp+="SRK/T";
		  break;
      }
      rt=pInfo->m_rectDraw;
	  pDC->TextOut(xb+rt.right/2,yb,Temp);	
	  yb+=sz.cy+sz.cy+2;
      if(pmp->m_bOD)
	  {
          m_szK1_value_r.TrimLeft();
		  if(m_szK1_value_r.IsEmpty())
				  m_szK1_value_r="0";
		  m_szK2_value_r.TrimLeft();
		  if(m_szK2_value_r.IsEmpty())
				  m_szK2_value_r="0";
          Temp0=pcp->m_gridDACONST.GetTextMatrix(3,1);
          Temp0.TrimLeft();
		  if(Temp0.IsEmpty())
			  Temp0="0";
		  if(bManualMeasure)
          {
			  Temp1=pcp->m_gridAL.GetTextMatrix(0,1);
              Temp1.TrimLeft();
		      if(Temp1.IsEmpty())
			      Temp1="0    ";
			  Temp.Format("  Dist = %5s mm;  K1 = %sD;  K2 = %sD;  K = %sD;  Rx = %s",Temp1,m_szK1_value_r,m_szK2_value_r,m_szK_value_r,Temp0);
          }
          else
		  {
			  Temp1=pmp->m_gridMaAvSd.GetTextMatrix(0,1);
			  Temp1.TrimLeft();
		      if(Temp1.IsEmpty())
			      Temp1="0    ";			 
              Temp.Format("    AL = %5s mm;  K1 = %sD;  K2 = %sD;  K = %sD;  Rx = %s",Temp1,m_szK1_value_r,m_szK2_value_r,m_szK_value_r,Temp0);
          }
	  }
	  else
	  {
		  m_szK1_value_l.TrimLeft();
		  if(m_szK1_value_l.IsEmpty())
				  m_szK1_value_l="0";
		  m_szK2_value_l.TrimLeft();
		  if(m_szK2_value_l.IsEmpty())
				  m_szK2_value_l="0";
		  Temp0=pcp->m_gridDACONST.GetTextMatrix(3,1);
          Temp0.TrimLeft();
		  if(Temp0.IsEmpty())
			  Temp0="0"; 
		  if(bManualMeasure)
          {
			  Temp1=pcp->m_gridAL.GetTextMatrix(0,1);
			  Temp1.TrimLeft();
		      if(Temp1.IsEmpty())
			      Temp1="0    ";
              Temp.Format("  Dist = %5s mm;  K1 = %sD;  K2 = %sD;  K = %sD;  Rx = %5s",Temp1,m_szK1_value_l,m_szK2_value_l,m_szK_value_l,Temp0);
          }
          else
		  {
			  Temp1=pmp->m_gridMaAvSd.GetTextMatrix(0,1);
			  Temp1.TrimLeft();
		      if(Temp1.IsEmpty())
			      Temp1="0    ";
	          Temp.Format("    AL = %5s mm;  K1 = %sD;  K2 = %sD;  K = %sD;  Rx = %5s",Temp1,m_szK1_value_l,m_szK2_value_l,m_szK_value_l,Temp0);
          }
	  }
      pDC->TextOut(xb,yb,Temp);
      sz=pDC->GetTextExtent(Temp);
      yb+=(short)(sz.cy+sz.cy);
	  ptRightTop.y=ptLeftTop.y=yb-sz.cy/2;	 
	  ptHorizontalRight.x=ptRightTop.x;
      lensrows=(short)pcp->m_gridLENSTABLE.GetRows();
	  cols=(short)pcp->m_gridLENSTABLE.GetCols();
	  Temp.Empty();
	  SIZE sz0;
	  rt.right-=20;
	 /////////////////////////////// 
	  ptRightTop.y=ptLeftTop.y=yb;
      for(r=1; r<lensrows;r++)
	  { 
		  Temp0=pcp->m_gridLENSTABLE.GetTextMatrix(r,0);
          if(Temp0.IsEmpty())
		  {
			  lensrows=r;
			  break;
          }
      }
	  if(atof(pcp->m_gridDACONST.GetTextMatrix(0,1))!=0.0)
	  {
		  bIUD=TRUE;
		  lensrows+=1;
      }
	  else
         bIUD=FALSE;
  if(lensrows>1)
  {
	  ptLeftBottom.x=ptHorizontalLeft.x=ptLeftTop.x=xb+rt.right/lensrows-7;
	  ptVerticalTop.y=ptRightTop.y=ptLeftTop.y=yb-sz.cy/2;
	  for(c=0; c<cols;c++)
      { //print lens table       
         if(c==1 || c==7|| c==5|| c==3)
			 continue;
         for(r=0; r<lensrows;r++)
		 { 				
			if(c==0 && r==0)
            {
              Temp="Lens Model";              
            }
			else if(bIUD==TRUE && r==(lensrows-1))
            {
               if(c==0)
                 Temp="User Defined";
			   else if(c==2)
                 Temp=pcp->m_gridDACONST.GetTextMatrix(1,1);
			   else if(c==4) 
                 Temp=pcp->m_gridDACONST.GetTextMatrix(0,1);
               else if(c==6)     
                 Temp=pcp->m_gridDACONST.GetTextMatrix(2,1);
			   else
				   continue;
            }
			else if(r==0)
            {
				  Temp="Mfg/p";
				  Temp0=pcp->m_gridLENSTABLE.GetTextMatrix(r,c);
				  Temp+=Temp0.Mid(4);
            }
			else
			{
			  
			  if(c==0)
			  {
				  Temp0=pcp->m_gridLENSTABLE.GetTextMatrix(r,c);
                  Temp1=pcp->m_gridLENSTABLE.GetTextMatrix(r,c+1);
				  Temp=Temp1+'/'+Temp0;
              }
			  else
              {
                  Temp0=pcp->m_gridLENSTABLE.GetTextMatrix(r,c);
                  Temp1=pcp->m_gridLENSTABLE.GetTextMatrix(r,c+1);
                  if(Temp1.IsEmpty())
					 Temp=Temp0;
				  else
					 Temp=Temp0+'/'+Temp1;
              }
            }
			pDC->TextOut(xb+rt.right/lensrows*r,yb,Temp);
            sz0=pDC->GetTextExtent(Temp);
			if(sz.cy<sz0.cy)
				sz=sz0;
		 }
		 yb+=sz.cy+5;
		 ptHorizontalRight.y=ptHorizontalLeft.y=yb-3;
         pDC->MoveTo(ptHorizontalLeft);
		 pDC->LineTo(ptHorizontalRight);
	  }	
	  //yb+=sz.cy+2;     
	  switch(m_nFormula)
      {
         default:
	  case 0:
          c= pcp->m_enMETHOD1TypeColStart;
		  break;
	  case 1:
          c= pcp->m_enMETHOD0TypeColStart;
		  break;
	  case 2:
          c= pcp->m_enSRKTTypeColStart;//column start
     	  break;
      }	 
	  cols=c+pcp->m_nMfgNumCols;
	   
	  for(r=1;r<lensrows;r++)
	  {
         Temp0.Format("%5s","  IOL");
         Temp1.Format("%5s","  REF");
		 pDC->TextOut(xb+rt.right/lensrows*r,yb,Temp0);
         pDC->TextOut(xb+rt.right/lensrows*r+rt.right/lensrows/2,yb,Temp1);
		 sz0=pDC->GetTextExtent(Temp1);
	     if(sz.cy<sz0.cy)
				sz=sz0;  
      } 
	  yb+=sz.cy+2;	 
	  for(k=2;k<pcp->m_nMfgNumRows;k++)
	  {  
        if(bIUD)
			r=pcp->m_nMfgNumRows+1;
		else
			r=1;
        for(rr=1;rr<lensrows;r+=pcp->m_nMfgNumRows,rr++)
		{
         if(bIUD && rr==lensrows-1)
			 break;
         Temp0.Format("%6s",pcp->m_gridCalculateTable.GetTextMatrix(r+k,c));
		 Temp1.Format("%6s",pcp->m_gridCalculateTable.GetTextMatrix(r+k,c+1));
		 //sz.cx=((rt.right-maxx)/((rows-1)/pcp->m_nMfgNumRows))*((r-1)/pcp->m_nMfgNumRows);
		 if(k==5)
		 {			
             m_pfont=pDC->SelectObject(&cfont);
         }
		 //pDC->TextOut(xb+maxx+sz.cx,yb,Temp0);
         pDC->TextOut(xb+rt.right/lensrows*rr,yb,Temp0);
         //sz.cx+=(rt.right-maxx)/((rows-1)/pcp->m_nMfgNumRows)/2;
		 //pDC->TextOut(xb+maxx+sz.cx,yb,Temp1);
		 pDC->TextOut(xb+rt.right/lensrows*rr+rt.right/lensrows/2,yb,Temp1);
		 sz0=pDC->GetTextExtent(Temp1);
		 if(k==5)        
		 {
             pDC->SelectObject(m_pfont);			 
         }
	     if(sz.cy<sz0.cy)
				sz=sz0;  
		}
        if(bIUD)
		{
		 r=1;
		 rr=lensrows-1;
         Temp0.Format("%6s",pcp->m_gridCalculateTable.GetTextMatrix(r+k,c));
		 Temp1.Format("%6s",pcp->m_gridCalculateTable.GetTextMatrix(r+k,c+1));
		 //sz.cx=((rt.right-maxx)/((rows-1)/pcp->m_nMfgNumRows))*((r-1)/pcp->m_nMfgNumRows);
		 if(k==5)
		 {			
             m_pfont=pDC->SelectObject(&cfont);
         }
		 //pDC->TextOut(xb+maxx+sz.cx,yb,Temp0);
         pDC->TextOut(xb+rt.right/lensrows*rr,yb,Temp0);
         //sz.cx+=(rt.right-maxx)/((rows-1)/pcp->m_nMfgNumRows)/2;
		 //pDC->TextOut(xb+maxx+sz.cx,yb,Temp1);
		 pDC->TextOut(xb+rt.right/lensrows*rr+rt.right/lensrows/2,yb,Temp1);
		 sz0=pDC->GetTextExtent(Temp1);
		 if(k==5)        
		 {
             pDC->SelectObject(m_pfont);			 
         }
	     if(sz.cy<sz0.cy)
				sz=sz0;  
        }
	    yb+=sz.cy+2;
      }
//	  yb+=sz.cy+2; 
      Temp="D Emms:"; 
      pDC->TextOut(xb,yb,Temp);
	  Temp= "METHOD1"; 
	  Temp0="METHOD0";
	  Temp1="SRK/T";
      yb+=sz.cy+2;  
      pDC->TextOut(xb,yb,Temp);
	  c= pcp->m_enMETHOD1TypeColStart;
	  if(bIUD)
			r=pcp->m_nMfgNumRows+1;
	  else
			r=1;
	  for(rr=1;rr<lensrows;r+=pcp->m_nMfgNumRows,rr++)
	  {
         if(bIUD && rr==lensrows-1)
			 break;
         Temp.Format("%6s",pcp->m_gridCalculateTable.GetTextMatrix(r,c+1));  
         //pDC->TextOut(xb+rt.right/lensrows*rr+rt.right/lensrows/2,yb,Temp);
		 pDC->TextOut(xb+rt.right/lensrows*rr+rt.right/lensrows/4,yb,Temp);
		 sz0=pDC->GetTextExtent(Temp);
	     if(sz.cy<sz0.cy)
				sz=sz0;    
      }	
	  if(bIUD)
	  {//user defined
		 r=1;
		 rr=lensrows-1;
         Temp.Format("%6s",pcp->m_gridCalculateTable.GetTextMatrix(r,c+1));  
         //pDC->TextOut(xb+rt.right/lensrows*rr+rt.right/lensrows/2,yb,Temp);
		 pDC->TextOut(xb+rt.right/lensrows*rr+rt.right/lensrows/4,yb,Temp);
		 sz0=pDC->GetTextExtent(Temp);
	     if(sz.cy<sz0.cy)
				sz=sz0;    
      }
	  yb+=sz.cy+2; 
	  pDC->TextOut(xb,yb,Temp1);
	  c=pcp->m_enSRKTTypeColStart;
       if(bIUD)
			r=pcp->m_nMfgNumRows+1;
	  else
			r=1;
	  for(rr=1;rr<lensrows;r+=pcp->m_nMfgNumRows,rr++)
	  {
         if(bIUD && rr==lensrows-1)
			 break;
         Temp.Format("%6s",pcp->m_gridCalculateTable.GetTextMatrix(r,c+1));  
         //pDC->TextOut(xb+rt.right/lensrows*rr+rt.right/lensrows/2,yb,Temp);
		 pDC->TextOut(xb+rt.right/lensrows*rr+rt.right/lensrows/4,yb,Temp);
		 sz0=pDC->GetTextExtent(Temp);
	     if(sz.cy<sz0.cy)
				sz=sz0;    
      }	
	  if(bIUD)
	  {
		 r=1;
		 rr=lensrows-1;
         Temp.Format("%6s",pcp->m_gridCalculateTable.GetTextMatrix(r,c+1));  
         //pDC->TextOut(xb+rt.right/lensrows*rr+rt.right/lensrows/2,yb,Temp);
		 pDC->TextOut(xb+rt.right/lensrows*rr+rt.right/lensrows/4,yb,Temp);
		 sz0=pDC->GetTextExtent(Temp);
	     if(sz.cy<sz0.cy)
				sz=sz0;    
      }
	  //////////////////////////////////////////////////////
      yb+=sz.cy+2;  
	  pDC->TextOut(xb,yb,Temp0);
	  c= pcp->m_enMETHOD0TypeColStart;
	   if(bIUD)
			r=pcp->m_nMfgNumRows+1;
	  else
			r=1;
	  for(rr=1;rr<lensrows;r+=pcp->m_nMfgNumRows,rr++)
	  {
         if(bIUD && rr==lensrows-1)
			 break;
         Temp.Format("%6s",pcp->m_gridCalculateTable.GetTextMatrix(r,c+1));  
         //pDC->TextOut(xb+rt.right/lensrows*rr+rt.right/lensrows/2,yb,Temp);
		 pDC->TextOut(xb+rt.right/lensrows*rr+rt.right/lensrows/4,yb,Temp);
		 sz0=pDC->GetTextExtent(Temp);
	     if(sz.cy<sz0.cy)
				sz=sz0;    
      }	
	  if(bIUD)
	  {
		 r=1;
		 rr=lensrows-1;
         Temp.Format("%6s",pcp->m_gridCalculateTable.GetTextMatrix(r,c+1));  
         //pDC->TextOut(xb+rt.right/lensrows*rr+rt.right/lensrows/2,yb,Temp);
		 pDC->TextOut(xb+rt.right/lensrows*rr+rt.right/lensrows/4,yb,Temp);
		 sz0=pDC->GetTextExtent(Temp);
	     if(sz.cy<sz0.cy)
				sz=sz0;    
      }
 }
	  yb+=sz.cy+2;  
	pDC->MoveTo(ptLeftTop);
    pDC->LineTo(ptRightTop);
    ptVerticalBottom.y=ptRightBottom.y=ptLeftBottom.y=yb; 
	ptVerticalTop.y=ptLeftTop.y;
	pDC->MoveTo(ptLeftBottom);
    pDC->LineTo(ptRightBottom);
    pDC->MoveTo(ptLeftTop);
    pDC->LineTo(ptLeftBottom);
    for(rr=1;rr<lensrows;rr++)
	{
        ptVerticalTop.x=ptVerticalBottom.x=xb+rt.right/lensrows*rr-7;
        pDC->MoveTo(ptVerticalTop);
        pDC->LineTo(ptVerticalBottom);  
    }	
}
    
	m_nStartPrint=0;
}

BOOL PrintPage::OnKillActive() 
{
	// TODO: Add your specialized code here and/or call the base class
	m_font.DeleteObject();
	return CPropertyPage::OnKillActive();
}
