#if !defined(AFX_YTVGRAPHCTRLCTL_H__43C60F15_64F7_11E3_8AC9_000629F770AC__INCLUDED_)
#define AFX_YTVGRAPHCTRLCTL_H__43C60F15_64F7_11E3_8AC9_000629F770AC__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

// YtvGraphCtrlCtl.h : Declaration of the CYtvGraphCtrlCtrl ActiveX Control class.

/////////////////////////////////////////////////////////////////////////////
// CYtvGraphCtrlCtrl : See YtvGraphCtrlCtl.cpp for implementation.

class CYtvGraphCtrlCtrl : public COleControl
{
	DECLARE_DYNCREATE(CYtvGraphCtrlCtrl)

// Constructor
public:
	CYtvGraphCtrlCtrl();
    void SetCurrentBitmap();
	BOOL m_bMakeOutputToExternalDC;
	CBitmap m_bmCurrentBitmap;
	CDC* m_pdcCurrentDisplayMemory;
	CBitmap * m_pbmCurrentOldBitmap;
	RECT m_rectExternalDevice;
	HDC m_hExternalDC;
	HBRUSH m_hFirstBrushHandle;
	BOOL m_bAutoResizeHeight;
	BOOL m_bOcu;
	CFont m_font;
	int m_nFontScaleCountBeginH;
	int m_nScaleTextStepHL;
	int m_nScaleTextStepHM;
	int m_nScaleTextStepHS;
	long m_nHPosionLeft;
	long m_nHPosionRight;
   	unsigned short m_nSpecterColumnNumber;
	unsigned short m_ushNumberCursors;
	unsigned short m_ushListNumberPoints;
	unsigned short m_ush3ListNumberPoints;
	short* m_pListCoor;
    short* m_pnCursorPositions;
	short* m_pnPrevCursorPositions;
	bool *m_pbCursorOn;
	int m_nPalleteSize;
    COLORREF* m_pclrPallette;
	COLORREF m_clrDividingLineColor;
	CBitmap ** m_ppOldBitmap;
	CDib m_dibm;
	int m_nOldStretchMode; 
	BOOL m_bStretch;
	BOOL m_bOddDisplay;
	unsigned short m_ushMaxNumberOfBuffers;
	unsigned short m_ushBufNumber;
	unsigned short m_ushPaintBufNumber;
	int m_nBitsPerPixel;
	unsigned short m_nSpecterMaxColumnNumber;
	BOOL m_bComplexData;
    DWORD m_uNumberPoints;
	int m_nMemorySize;
	DWORD m_nMaxGraphHeight;
	DWORD m_nHalfMaxGraphHeight;
	CDC **m_ppdcDisplayMemory;
	CBitmap* m_pbmBitmap;
	double m_dNoiseLevel;
	double m_dMaxFilterOff;
	BOOL m_bMaxFilterOff;
	BOOL m_bLeftCursor;
	BOOL m_bRightCursor;
	BOOL m_bTopCursor;
	BOOL m_bBottomCursor;
	BOOL m_bPrevLeftCursor;
	BOOL m_bPrevRightCursor;
	BOOL m_bPrevTopCursor;
	BOOL m_bPrevBottomCursor;
	int  m_nLeftCursor;
	int  m_nRightCursor;
	int  m_nTopCursor;
	int  m_nBottomCursor;
	short  m_nGraphType;
	POINT* m_ptPoints;
	POINT* m_ptImPoints;
	CPen *m_OldPen;
	CBrush *m_OldBrush;
	CBitmap *m_OldBitmap;
	///ScalePlank
	short m_shVisibilityState;
	COLORREF m_clrScalePlankColor;
	COLORREF m_clrScaleBackPlankColor;
	CPen m_penScalePlankPen;
	short m_shBegXH;
	short m_shBegYH;
	short m_shLenXH;
	short m_shLenYH;
	short m_shHSmall;
	short m_shHMedium;
	short m_shHLong;
	short m_shStepSmallH;
	short m_shStepMediumH;
	short m_shStepLongH;
	short m_shDirectionUpDownCenterH;
	short m_shAxisLineTypeH;
	////////////////////////////
	unsigned short m_ushMaxWidth;
	double m_dMinHeight;
	double m_dMaxHeight;
	double m_dVMultifactor;
	double m_dHMultifactor;
	int m_nVPosBottom;
	int m_nVPosTop;
	int m_nNumb;
	CRect m_rcMemBounds;
	double* m_dpDataBuf;
	double* m_dpMaxMinDataBuf;
	int* m_npMaxMinDataBuf;
	COLORREF m_clrChartBrush;
	CBrush m_cbrChartBrush;
	CPen m_penChartPen;
	CPen m_penChartPenIm;
	CPen m_penChartBrushPen;
	int m_nPenChartStyle;
	int m_nPenChartWidth;
	BOOL m_bComputeMinMax;
	COLORREF m_clrChartPen;
	COLORREF m_clrChartPenIm;
	BOOL m_bCleanByBrush;
	void DrawScalePlankHoriz(HDC hdc);
	void DrawLines(HDC hdc,CPen* ppen);
	bool ChangeCursorState(BOOL bNewValue,unsigned short index);
	void SetBitmaps();
	void InitSpecter();
	void InitMaxMin();
	void InitMemDC();
	void FillBufferBrush(unsigned short i);
	void InitXCoor();
	void InitYCoor();
	void InitXOCUCoor();
	void InitYOCUCoor();
	void OnOCUPaint(); 
	void FillYPoints();
	void UpdateMemorySize(int nNewValue); 
	void SetMaxMinDataAtPosition(int i);
	void DrawDirectLineInvert(int xfrom, int yfrom, int xto, int yto,HDC hdc);
	void DrawLineInvert(int xfrom, int yfrom, int xto, int yto,int BufNumber);
// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CYtvGraphCtrlCtrl)
	public:
	virtual void OnDraw(CDC* pdc, const CRect& rcBounds, const CRect& rcInvalid);
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
	virtual void DoPropExchange(CPropExchange* pPX);
	virtual void OnResetState();
	virtual DWORD GetControlFlags();
	virtual BOOL Create(LPCTSTR lpszClassName, LPCTSTR lpszWindowName, DWORD dwStyle, const RECT& rect, CWnd* pParentWnd, UINT nID, CCreateContext* pContext = NULL);
	virtual BOOL OnChildNotify(UINT message, WPARAM wParam, LPARAM lParam, LRESULT* pLResult);
	//}}AFX_VIRTUAL

// Implementation
protected:
	~CYtvGraphCtrlCtrl();

	DECLARE_OLECREATE_EX(CYtvGraphCtrlCtrl)    // Class factory and guid
	DECLARE_OLETYPELIB(CYtvGraphCtrlCtrl)      // GetTypeInfo
	DECLARE_PROPPAGEIDS(CYtvGraphCtrlCtrl)     // Property page IDs
	DECLARE_OLECTLTYPE(CYtvGraphCtrlCtrl)		// Type name and misc status

	// Subclassed control support
	BOOL IsSubclassedControl();
	LRESULT OnOcmCommand(WPARAM wParam, LPARAM lParam);

// Message maps
	//{{AFX_MSG(CYtvGraphCtrlCtrl)
	afx_msg void OnPaint();
	afx_msg void OnSize(UINT nType, int cx, int cy);
	afx_msg HBRUSH CtlColor(CDC* pDC, UINT nCtlColor);
	afx_msg int OnCreate(LPCREATESTRUCT lpCreateStruct);
	afx_msg void OnClose();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()

// Dispatch maps
	//{{AFX_DISPATCH(CYtvGraphCtrlCtrl)
	afx_msg double GetHMultiFactor();
	afx_msg void SetHMultiFactor(double newValue);
	afx_msg double GetVMultiFactor();
	afx_msg void SetVMultiFactor(double newValue);
	afx_msg BOOL GetComplexGraph();
	afx_msg void SetComplexGraph(BOOL bNewValue);
	afx_msg double GetNoiseLevel();
	afx_msg void SetNoiseLevel(double newValue);
	afx_msg short GetGraphType();
	afx_msg void SetGraphType(short nNewValue);
	afx_msg long GetPalleteSize();
	afx_msg void SetPalleteSize(long nNewValue);
	afx_msg short GetBitsPerPixel();
	afx_msg void SetBitsPerPixel(short nNewValue);
	afx_msg short GetNumberOfBuffers();
	afx_msg void SetNumberOfBuffers(short nNewValue);
	afx_msg short GetMaxWidth();
	afx_msg void SetMaxWidth(short nNewValue);
	afx_msg double GetMaxHeight();
	afx_msg void SetMaxHeight(double newValue);
	afx_msg double GetMinHeight();
	afx_msg void SetMinHeight(double newValue);
	afx_msg long GetMaxGraphHeight();
	afx_msg void SetMaxGraphHeight(long nNewValue);
	afx_msg BOOL GetComputeMinMax();
	afx_msg void SetComputeMinMax(BOOL bNewValue);
	afx_msg BOOL GetStretch();
	afx_msg void SetStretch(BOOL bNewValue);
	afx_msg long GetDividingLineColor();
	afx_msg void SetDividingLineColor(long nNewValue);
	afx_msg short GetDisplayBufferNumber();
	afx_msg void SetDisplayBufferNumber(short nNewValue);
	afx_msg BOOL GetOddDisplay();
	afx_msg void SetOddDisplay(BOOL bNewValue);
	afx_msg BOOL GetReSizeHeight();
	afx_msg void SetReSizeHeight(BOOL bNewValue);
	afx_msg BOOL GetOcuMethod();
	afx_msg void SetOcuMethod(BOOL bNewValue);
	afx_msg BOOL GetDrawScalePlank();
	afx_msg void SetDrawScalePlank(BOOL bNewValue);
	afx_msg long GetScalePlankColor();
	afx_msg void SetScalePlankColor(long nNewValue);
	afx_msg BOOL GetCleanByBrush();
	afx_msg void SetCleanByBrush(BOOL bNewValue);
	afx_msg long GetHPosionLeft();
	afx_msg void SetHPosionLeft(long nNewValue);
	afx_msg long GetHPositionRight();
	afx_msg void SetHPositionRight(long nNewValue);
	afx_msg long GetTopVerticalPosition();
	afx_msg void SetTopVerticalPosition(long nNewValue);
	afx_msg long GetBackTextColor();
	afx_msg void SetBackTextColor(long nNewValue);
	afx_msg long GetBottomVerticalPosition();
	afx_msg void SetBottomVerticalPosition(long nNewValue);
	afx_msg long GetExternalDeviceContext();
	afx_msg void SetExternalDeviceContext(long nNewValue);
	afx_msg long GetChartLineColor();
	afx_msg void SetChartLineColor(long nNewValue);
	afx_msg long GetChartBrushColor();
	afx_msg void SetChartBrushColor(long nNewValue);
	afx_msg long GetChartLineSecondColor();
	afx_msg void SetChartLineSecondColor(long nNewValue);
	afx_msg void FillBrush();
	afx_msg void SetInitMaxMinCoorY();
	afx_msg void DrawVerticalCursors();
	afx_msg void CleanReDraw(short CleanRedraw);
	afx_msg long PixelsFromUnitsLength(double LengthInUnits);
	afx_msg double UnitsLengthFromPixels(long NumberPixels);
	afx_msg long PixelFromDataXCoor(long InpDataXCoor);
	afx_msg double UnitLengthFromInpDataInputCoorX(long DataInpCoorX);
	afx_msg long InpXCoorFromPixels(long Pixels);
	afx_msg long GetPoints(short FAR* PointsArray);
	afx_msg void SetPoints(short FAR* PointsArray, long nNewValue);
	afx_msg long GetPositionFloat(float FAR* SetPos);
	afx_msg void SetPositionFloat(float FAR* SetPos, long nNewValue);
	afx_msg long GetPositionDouble(double FAR* ArrayPos);
	afx_msg void SetPositionDouble(double FAR* ArrayPos, long nNewValue);
	afx_msg long GetPositionInt(long FAR* ArrayPos);
	afx_msg void SetPositionInt(long FAR* ArrayPos, long nNewValue);
	afx_msg long GetPalleteColors(long FAR* PalleteRGBColors);
	afx_msg void SetPalleteColors(long FAR* PalleteRGBColors, long nNewValue);
	afx_msg BOOL GetFilterMaximum(double FAR* MaximumValue);
	afx_msg void SetFilterMaximum(double FAR* MaximumValue, BOOL bNewValue);
	afx_msg BOOL GetLeftCursor(long FAR* pPosition);
	afx_msg void SetLeftCursor(long FAR* pPosition, BOOL bNewValue);
	afx_msg BOOL GetRightCursor(long FAR* pPosition);
	afx_msg void SetRightCursor(long FAR* pPosition, BOOL bNewValue);
	afx_msg BOOL GetTopCursor(long FAR* pPosition);
	afx_msg void SetTopCursor(long FAR* pPosition, BOOL bNewValue);
	afx_msg BOOL GetBottomCursor(long FAR* pPosition);
	afx_msg void SetBottomCursor(long FAR* pPosition, BOOL bNewValue);
	afx_msg short GetCursors(short FAR* pCursors);
	afx_msg void SetCursors(short FAR* pCursors, short nNewValue);
	afx_msg BOOL GetCursorOnOff(short index);
	afx_msg void SetCursorOnOff(short index, BOOL bNewValue);
	afx_msg short GetCursorPosition(short index);
	afx_msg void SetCursorPosition(short index, short nNewValue);
	afx_msg long GetIPoints(long FAR* PointsArray);
	afx_msg void SetIPoints(long FAR* PointsArray, long nNewValue);
	afx_msg short GetScalePlank(short FAR* BegX, short FAR* BegY, short FAR* LenX, short FAR* LenY, short FAR* HSmall, short FAR* HMedium, short FAR* HLong, short FAR* StepSmall, short FAR* StepMedium, short FAR* StepLong, short FAR* DirectionUpDownCenter, short FAR* AxisLineType);
	afx_msg void SetScalePlank(short FAR* BegX, short FAR* BegY, short FAR* LenX, short FAR* LenY, short FAR* HSmall, short FAR* HMedium, short FAR* HLong, short FAR* StepSmall, short FAR* StepMedium, short FAR* StepLong, short FAR* DirectionUpDownCenter, short FAR* AxisLineType, short nNewValue);
	afx_msg short GetDrawLines(short FAR* pX, short FAR* pY, short FAR* pType);
	afx_msg void SetDrawLines(short FAR* pX, short FAR* pY, short FAR* pType, short nNewValue);
	afx_msg long GetScalePlankTextHoriz(long FAR* StepSmall, long FAR* StepMedium, long FAR* StepLong);
	afx_msg void SetScalePlankTextHoriz(long FAR* StepSmall, long FAR* StepMedium, long FAR* StepLong, long nNewValue);
	afx_msg BOOL GetExternalDeviceContextRectangle(short FAR* pleft, short FAR* ptop, short FAR* pwidth, short FAR* pheight);
	afx_msg void SetExternalDeviceContextRectangle(short FAR* pleft, short FAR* ptop, short FAR* pwidth, short FAR* pheight, BOOL bNewValue);
	//}}AFX_DISPATCH
	DECLARE_DISPATCH_MAP()

	afx_msg void AboutBox();

// Event maps
	//{{AFX_EVENT(CYtvGraphCtrlCtrl)
	void FireCurrentBuffer(short BufferNumber)
		{FireEvent(eventidCurrentBuffer,EVENT_PARAM(VTS_I2), BufferNumber);}
	void FireCursorCurrentValues(short TypeOfCursor, long CursorCoorX, long CursorCoorY, double DataValue)
		{FireEvent(eventidCursorCurrentValues,EVENT_PARAM(VTS_I2  VTS_I4  VTS_I4  VTS_R8), TypeOfCursor, CursorCoorX, CursorCoorY, DataValue);}
	//}}AFX_EVENT
	DECLARE_EVENT_MAP()

// Dispatch and event IDs
public:
	enum {
	//{{AFX_DISP_ID(CYtvGraphCtrlCtrl)
	dispidHMultiFactor = 1L,
	dispidVMultiFactor = 2L,
	dispidComplexGraph = 3L,
	dispidNoiseLevel = 4L,
	dispidGraphType = 5L,
	dispidPalleteSize = 6L,
	dispidBitsPerPixel = 7L,
	dispidNumberOfBuffers = 8L,
	dispidMaxWidth = 9L,
	dispidMaxHeight = 10L,
	dispidMinHeight = 11L,
	dispidMaxGraphHeight = 12L,
	dispidComputeMinMax = 13L,
	dispidStretch = 14L,
	dispidDividingLineColor = 15L,
	dispidDisplayBufferNumber = 16L,
	dispidOddDisplay = 17L,
	dispidReSizeHeight = 18L,
	dispidOcuMethod = 19L,
	dispidDrawScalePlank = 20L,
	dispidScalePlankColor = 21L,
	dispidCleanByBrush = 22L,
	dispidHPosionLeft = 23L,
	dispidHPositionRight = 24L,
	dispidTopVerticalPosition = 25L,
	dispidBackTextColor = 26L,
	dispidBottomVerticalPosition = 27L,
	dispidExternalDeviceContext = 28L,
	dispidChartLineColor = 29L,
	dispidChartBrushColor = 30L,
	dispidChartLineSecondColor = 31L,
	dispidPoints = 41L,
	dispidPositionFloat = 42L,
	dispidPositionDouble = 43L,
	dispidPositionInt = 44L,
	dispidPalleteColors = 45L,
	dispidFillBrush = 32L,
	dispidFilterMaximum = 46L,
	dispidLeftCursor = 47L,
	dispidRightCursor = 48L,
	dispidTopCursor = 49L,
	dispidBottomCursor = 50L,
	dispidSetInitMaxMinCoorY = 33L,
	dispidCursors = 51L,
	dispidCursorOnOff = 52L,
	dispidCursorPosition = 53L,
	dispidDrawVerticalCursors = 34L,
	dispidIPoints = 54L,
	dispidScalePlank = 55L,
	dispidDrawLines = 56L,
	dispidCleanReDraw = 35L,
	dispidScalePlankTextHoriz = 57L,
	dispidPixelsFromUnitsLength = 36L,
	dispidUnitsLengthFromPixels = 37L,
	dispidPixelFromDataXCoor = 38L,
	dispidUnitLengthFromInpDataInputCoorX = 39L,
	dispidInpXCoorFromPixels = 40L,
	dispidExternalDeviceContextRectangle = 58L,
	eventidCurrentBuffer = 1L,
	eventidCursorCurrentValues = 2L,
	//}}AFX_DISP_ID
	};
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_YTVGRAPHCTRLCTL_H__43C60F15_64F7_11E3_8AC9_000629F770AC__INCLUDED)
