//{{AFX_INCLUDES()
#include "msflexgrid.h"
#include "msflexgrid1.h"
//}}AFX_INCLUDES
#if !defined(AFX_CALCULATORPAGE_H__5D24F6C1_BAF1_419B_A0A0_7C54A014CBC9__INCLUDED_)
#define AFX_CALCULATORPAGE_H__5D24F6C1_BAF1_419B_A0A0_7C54A014CBC9__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// CalculatorPage.h : header file
//

/////////////////////////////////////////////////////////////////////////////
// CCalculatorPage dialog
#define MaxNumbFieldsInDbPatientRec 100
#define MaxNumbFieldsInDbDoctorRec 40
#define MaxNumbFieldsInDbLensStyleRec 100
class YtvEditGridDial;
class CCalculatorPage : public CPropertyPage
{
	DECLARE_DYNCREATE(CCalculatorPage)

// Construction
public:
	CCalculatorPage();
	~CCalculatorPage();
	virtual BOOL OnKillActive();
	virtual BOOL OnSetActive();
	void ReadRegSesStat();
	CString m_szTodayDate;
	afx_msg LRESULT CalculateAll(WPARAM wp,LPARAM lp);
	YtvEditGridDial* m_pgd;
    CString m_strAddionalRegistryOld;
	static	enum entypeRegistryNodes  m_enTypeRegNode;
    static char* m_pszPatientRecFormat[];
	static char* m_pszDoctorRecFormat[];
	static char* m_pszLensTypeRecFormat[];
	static char* m_pszFullPatientRecFormat[];
	static char* m_pszFullDoctorRecFormat[];
	static char* m_pszFullLensTypeRecFormat[];
	static char* m_pszEditNewLensTypeRecFormat[];
	static char* m_pszMeasureHistoryTypeRecFormat[];
	static char* m_pszCalculatorTypeRecFormat[];
	static char* m_pszScansTypeRecFormat[];
	static char* m_pszPrintTypeRecFormat[];
	static struct sttypeRegistryNodes m_arListReg[];	
	CString m_pszDbLensStyleRec[MaxNumbFieldsInDbLensStyleRec];
	CString m_pszDbDoctorRec[MaxNumbFieldsInDbDoctorRec];
	CString m_szNoteD;//=YtvGetProfileString(m_arListReg[m_enTypeRegNode].Data[0],m_arListReg[m_enTypeRegNode].Format[3],"",1);
	CString m_szDOfficeName;//=YtvGetProfileString(m_arListReg[m_enTypeRegNode].Data[0],m_arListReg[m_enTypeRegNode].Format[4],"",1);
	CString m_szDAddress;
	CMSFlexGrid	*m_pGrid;
	int m_nLastSel;
	int m_NumbRecords;

// Dialog Data
	//{{AFX_DATA(CCalculatorPage)
	enum { IDD = IDD_CALCULATOR };
	CButton	m_btCalculate;
	CButton	m_btOD_OS;
	CMSFlexGrid	m_gridDACONST;
	CMSFlexGrid	m_gridAL;
	CMSFlexGrid	m_gridAPATID;
	CMSFlexGrid	m_gridLENSTABLE;
	BOOL	m_bCalculate;
	CString	m_strValidMessage;
	CMSFlexGrid	m_gridCalculateTable;
	//}}AFX_DATA
	int ReadRegDB();
	int LensReadRegistryDB();
    int DoctorRefReadRegistryDB();
	void SetEyePar();
	//////////////////////////calculator table subroutines & parameters
	void CalculateMFG();
    void CalculateIOLSquare(int BegRow, int BegCol,double AL, double K1D, double K2D, double KD,double ACD,double A_Const, double SF,double Rx);
	void ComputeMETHOD1Formulas(int BegRow, int BegCol,double AL, double KD,double HofACD, double A_Const,double Rx);
	void ComputeSrk_tFormulas(int BegRow, int BegCol,double A_Const,double AL, double K1D, double K2D,double ACD);
	void ComputeMETHOD0Formulas(int BegRow, int BegCol,double AL, double KD, double SF,double Rx);
	RECT m_RTgridDACONST;
	RECT m_RTgridAL;
	double	m_dPersonAl;
	double	m_dPersonIOL;
	double	m_dPersonK;
	double	m_dPORef;
    double	m_dPersACD;
	double  m_dPersSF;
	double  m_dPersA_Const;
	enum IOLPowerTypes
    {
       m_enPowerTypeUndefined=0,//column start
       m_enMETHOD1TypeColStart=1,//column start
       m_enSRKTTypeColStart=3,//column start
	   m_enMETHOD0TypeColStart=5//column start	  
    }m_enCurrentIOLPowerType; 
    enum LensParTypes
    {
       m_enLensName=0,//column 
       m_enLensMfg=1,//column 
	   m_enLensMfgAcd=2,//column 
	   m_enLensPsAcd=3,//column 
	   m_enLensMfgAC=4,//column 
	   m_enLensPsAC=5,//column 
	   m_enLensMfgSF=6,//column 
	   m_enLensPsSF=7,//column 
	   m_enUdAC=0,//row
	   m_enUdACD=1,//row
	   m_enUdSF=2,//row
	   m_enUdRx=3,//row
	   m_enUdMCalcAl=0,//row
	   m_enUdDEdK1=1,//row
	   m_enUdDEdK2=2,//row
	   m_enUdDEdKAv=3//row
    }m_enCurrentLensPar; 
	int m_nCurrentIOLTableRowStart;
	int m_nMfgNumRows;//number rows used for IOL table
	int m_nMfgNumCols;//number columns used for IOL table 
	int m_nCalcLastFiledRow;
	BOOL m_bOD;
	CString	m_szDoctorId;
	CString	m_szPatient_Id;
	CString	m_szFirstname;
	CString	m_szLastname;
	CString	m_szP_Address;
	CString	m_szP_city;
	CString	m_szP_zip;
	CString	m_szK_value_l;
	CString	m_szK_value_r;
	CString	m_szK1_value_l;
	CString	m_szK1_value_r;
	CString	m_szK2_value_l;
	CString	m_szK2_value_r;
	CString	m_szP_age;
	CString	m_szDob_mm;
	CString	m_szDob_yy;
	CString	m_szDob_dd;
	CString	m_szNote;
	CString	m_szDoctorName;
	int		m_nGender;
	CString	m_szP_phone;
	CString	m_szP_state;
   // CImageList m_imlImList;
	HBRUSH   m_hbrDialBrush;
	COLORREF m_clrDialBrush;
	COLORREF m_clrDialBack;
	COLORREF m_clrDialFront;
	HBRUSH   m_hbrButtonsBrush;
    COLORREF m_clrButtonsBrush; 
	COLORREF m_clrButtonsBack;
	COLORREF m_clrButtonsFront;
	HBRUSH   m_hbrStaticBrush;
    COLORREF m_clrStaticBrush; 
	COLORREF m_clrStaticBack;
	COLORREF m_clrStaticFront;
	COLORREF m_clrMsgBoxesBrush; 
	HBRUSH   m_hbrMsgBoxesBrush;
	COLORREF m_clrMsgBoxesBack;
	COLORREF m_clrMsgBoxesFront;
	COLORREF m_clrEditBoxesBrush; 
	HBRUSH   m_hbrEditBoxesBrush;
	COLORREF m_clrEditBoxesBack;
	COLORREF m_clrEditBoxesFront;
	COLORREF m_clrScrollBarsBrush; 
	HBRUSH   m_hbrScrollBarsBrush;
	COLORREF m_clrScrollBarsBack;
	COLORREF m_clrScrollBarsFront;
	COLORREF m_clrListBoxesBrush; 
	HBRUSH   m_hbrListBoxesBrush;
	COLORREF m_clrListBoxesBack;
	COLORREF m_clrListBoxesFront;

// Overrides
	// ClassWizard generate virtual function overrides
	//{{AFX_VIRTUAL(CCalculatorPage)
	public:
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	// Generated message map functions
	//{{AFX_MSG(CCalculatorPage)
	afx_msg HBRUSH OnCtlColor(CDC* pDC, CWnd* pWnd, UINT nCtlColor);
	virtual BOOL OnInitDialog();
	afx_msg void OnCalculate();
	afx_msg void OnOdOsBt();
	afx_msg void OnClickGridaconst();
	afx_msg void OnClickCalcTable();
	afx_msg void OnClickLenstable();
	afx_msg void OnRowColChangeGridal();
	afx_msg void OnSelChangeGridal();
	afx_msg void OnSelChangeGridaconst();
	afx_msg void OnRowColChangeGridaconst();
	afx_msg void OnClickGridpatid();
	DECLARE_EVENTSINK_MAP()
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()

};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_CALCULATORPAGE_H__5D24F6C1_BAF1_419B_A0A0_7C54A014CBC9__INCLUDED_)
